<template slot="header" slot-scope="scope">
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item style="float:right;">
        <!-- <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button> -->
        <el-button type="primary" icon="el-icon-plus" size="mini" @click="handleAdd">添加</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="personnelList" @selection-change="handleSelectionChange">
      <el-table-column label="油站员工主键id" v-if="false" align="center" prop="personnelId" />
      <el-table-column label="员工姓名" align="center" prop="personnelName" />
      <el-table-column label="负责枪号" align="center" prop="gunNo" />
      <el-table-column label="加油站id"  v-if="false" align="center" prop="stationId" />
      <el-table-column label="加油站名称" align="center" prop="stationName" />
      <!-- <el-table-column label="二维码" align="center" prop="qrCode" /> -->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <!-- <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
          >微信绑定</el-button> -->
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['station:personnel:edit']"
          >修改</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改油站员工信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="姓名" prop="personnelName">
          <el-input v-model="form.personnelName" placeholder="请输入员工姓名" />
        </el-form-item>
        <el-form-item label="负责枪号" prop="gunNo">
          <el-checkbox-group v-model="gunNoList">
            <el-checkbox
              v-for = "item in checkList"
              :key=item.oilGunId
              :label="item.oilGunNo"
              :value="item.oilGunNo"
            >
              {{item.oilGunNo+"号枪/"+item.oilName}}
            </el-checkbox>
          </el-checkbox-group>
        </el-form-item>
        <el-form-item label="手机号" prop="personnelPhone">
          <el-input v-model="form.personnelPhone" placeholder="请输入员工手机号" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listPersonnel, getPersonnel, delPersonnel, addPersonnel, updatePersonnel, exportPersonnel } from "@/api/station/personnel";
import {stationinfo,listGun} from "@/api/station/gun";
import { getDept } from "@/api/system/dept";
export default {
  name: "Personnel",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 油站员工信息表格数据
      personnelList: [],
      stationOptions:[],
      checkList:[],
      gunNoList:[],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        personnelName: null,
        gunNo: null,
        stationId: null,
        stationName: null,
        qrCode: null,
        personnelPhone: null
      },
      // 查询参数
      queryInfo: {
        stationId: null
      },
      query:{
        deptId: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
    this.query.deptId =this.$store.selectDeptId;
    if(this.query.deptId ==null || this.query.deptId ==""){
      this.query.deptId  =this.$store.state.user.deptId;
    }
    stationinfo(this.query).then(response => {
      this.stationOptions = response.rows;
    });
  },
  methods: {
    /** 查询油站员工信息列表 */
    getList() {
      this.loading = true;
      this.queryParams.stationId=this.$store.selectDeptId;
      if(this.queryParams.stationId==null || this.queryParams.stationId==""){
        this.queryParams.stationId =this.$store.state.user.deptId;
      }
      listPersonnel(this.queryParams).then(response => {
        this.queryParams.stationId=null;
        this.personnelList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    onInstitutionChang(e){
      let obj = {};
      obj = this.stationOptions.find((item)=>{//这里的userList就是上面遍历的数据源
        return item.deptId === e;//筛选出匹配数据
      })

      this.form.stationName=obj.deptName;
      this.queryInfo.stationId=obj.deptId;
      listGun(this.queryInfo).then(response => {
        this.checkList = response.rows;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        personnelId: null,
        personnelName: null,
        gunNo: null,
        stationId: null,
        stationName: null,
        qrCode: null,
        personnelPhone: null
      };
      this.resetForm("form");
      this.gunNoList.length=0;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.personnelId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.deptId=this.$store.selectDeptId;
      if(this.deptId==null || this.deptId==""){
        this.deptId =this.$store.state.user.deptId;
      }
      getDept(this.deptId).then(response => {
          this.deptInfo = response.data;
          if(this.deptInfo.jiBie==2){
             this.open = true;
            this.title = "添加油站员工信息";
            this.form.stationId=this.deptInfo.deptId;
            this.form.stationName=this.deptInfo.deptName;
            this.queryInfo.stationId=this.deptInfo.deptId;
            listGun(this.queryInfo).then(response => {
              this.checkList = response.rows;
            });
          }else{
              this.msgSuccess("请选择油站");
          }
      });
     
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const personnelId = row.personnelId || this.ids
      getPersonnel(personnelId).then(response => {
        this.form = response.data;
        if(this.form.gunNo!=null &&this.form.gunNo!="" ){
          this.gunNoList=this.form.gunNo.split(",");
        }
        this.queryInfo.stationId=row.stationId;
        listGun(this.queryInfo).then(response => {
          this.checkList = response.rows;
        });
        this.open = true;
        this.title = "修改油站员工信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if(this.gunNoList !=null && this.gunNoList.length>0){
            //判断
            let list=[];
            for(let i=0;i<this.gunNoList.length;i++){
              for(let j=0;j<this.checkList.length;j++){
                if(this.gunNoList[i]==this.checkList[j].oilGunNo){
                  list.push(this.checkList[j].oilGunNo);
                }
              }
            }
          
            this.form.gunNo=list.toString();
          }
          if (this.form.personnelId != null) {
            updatePersonnel(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPersonnel(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const personnelIds = row.personnelId || this.ids;
      this.$confirm('是否确认删除油站员工信息', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPersonnel(personnelIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有油站员工信息数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportPersonnel(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    }
  }
};
</script>
